﻿namespace Models;

public class Cell
{
    public Position Pos { get; private set; }

    private int? value;
    public int? Value {
        get
        {
            return value;
        }
        set
        {
            if (value < 0)
            {
                throw new Exception("La valeur doit être supérieure à 0");
            }
            this.value = value;
        }
    }

    private string Type { get; set; }

    private string? Background { get; set; }

    public Cell(int x, int y)
    {
        Pos = new Position(x, y);
    }

    public string GetCellType() => Type;


    // Redefinition de l'opérateur == pour comparer deux cellules
    public override bool Equals(object? obj)
    {
        if (obj == null || GetType() != obj.GetType())
        {
            return false;
        }
        Cell c = (Cell)obj;
        return (Pos.X == c.Pos.X) && (Pos.Y == c.Pos.Y);
    }

    // Redefinition de la méthode de Hash pour l'opérateur ==
    public override int GetHashCode()
    {
        return Pos.X * Pos.Y;
    } 
}